#pragma once

#include <stdint.h>
#include <list>
#include <map>
#include <string>
#include <fstream>
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <math.h>

#include <QtCore>
#include <QTime>
#include <QString>
#include <QSqlDatabase>
#include <QSqlQuery>
#include <QSqlError>
#include <QDebug>
#include <QMessageBox>
#include <QDebug>
#include <QList>
#include <QTimer>
#include <QMap>
#include <QBitArray>
#include <QBitmap>
#include <QDate>
#include <QDateTime>
#include <QBuffer>
#include <QFileDialog>
#include <QWidget>
#include <QShortcut>

using namespace std;

// Befinden wir uns im Debug Modus ohne das USB Device?
#define USBMODULE false
#define DEBUGMODE true
#define DEBUGDEPTH 4 // Bis in welche Ebene sollen Debugausgaben ausgegeben werden?

// Wie soll die Konsolenausgabe aussehen?
#define WIDTHID 3
#define WIDTHTYPE 16
#define WIDTHNAME 16
#define WIDTHZEIT 16
//#define WIDTH

// USB Datenverbindung korrekt definieren
#define NAMELENGTH 4
#define GRUNDFREQ 15625
#define TOLERANCE 15 // in %
#define VENDORID 0x16c0
#define PRODUCTID 0x05df
#define MAXPLAYER 6
#define IRABSTAND 0.043 // Abstand der IR Dioden [m]
#define USBRQ_HID_GET_REPORT 0x01

// Interne Variablen
#define ZEITRENNEN 1
#define RUNDENRENNEN 0

// Returnvariablen
#define RETSUCESS 0
#define RETFAIL 1

// Variable zur Rennen::LCD Aktualisierung
#define RENNENTIMESTEP 20

// Variable zur Abholung der Daten aus dem USB Modul
#define USBTIMESTEP 500

// SQLITE Anbindung
static QString DBTYPE = "QSQLITE";
static QString DBNAME = "Carrera.db";
static QString DBUSER = "Digital";
static QString DBPASS = "1:32";

typedef map<QString,QString> StrMap;
typedef map<QString,QString>::iterator StrMapIt;

/// Der Aufbau den zu emfpangenen Datensatzes
typedef struct send {
    // die Rückrechnung aus der Frequenz des Fahrzeugs
    uint8_t regler_id;
    // Die aktuelle Rennzeit, sobald das Fahrzeug die erste IR durchfährt
    uint32_t msc;
    // der Offset in ms, den das Fahrzeug zur zweiten IR benötigt.
    uint16_t speed;
    // in welchem Slot fährt das Fahrzeug?
    uint8_t slot;
}usb_data;


class CLCObject;
typedef struct Pairs {
    CLCObject* Fahrer;
    CLCObject* Slotcar;
    int iID,
        iPosition,
        iRegler;
} Pairs;

extern bool operator < (const Pairs& lhs, const Pairs& rhs);
extern bool operator > (const Pairs& lhs, const Pairs& rhs);
